#!/bin/bash
#
# Reads a semicolon separated file called music.ssv and transcodes music,
# trim them to the specified length and creates misc code snippets for
# Gamecora TV.
#
IFS=$'\n'
first="1"
outfolder="../../../../JSTV/gamecora/programs-common/music"
len=90 # Trim to 1m 30s
rm $outfolder/*
json="";
html="";
for a in $(cat music.ssv|sed "s/“/\"/g;s/”/\"/g"|grep -v "^#"); do

        title="$(echo "$a"|sed "s/;.*//")";
        a="$(echo "$a"|sed "s/^[^;]*;//")";
       
        author="$(echo "$a"|sed "s/;.*//")";
        a="$(echo "$a"|sed "s/^[^;]*;//")";

        link="$(echo "$a"|sed "s/;.*//")";
        a="$(echo "$a"|sed "s/^[^;]*;//")";

        file="$(echo "$a"|sed "s/;.*//")";
        a="$(echo "$a"|sed "s/^[^;]*;//")";

        out="$(echo "$file"|sed "s/.mp3$/.ogg/")"

        echo $title" ("$author")"
        echo $link
        echo FILE: $file
        echo "---"

        json="$json{name:'intro',files:{\"audio/mp3\":\"programs-common/music/$file\",\"audio/ogg\":\"programs-common/music/$out\"}},\n"
        html="$html<li><a href=\"$link\">$title</a> by <b>$author</b></li>\n"

        avconv -y -i "$file" -ab 96k -ss 0 -t $len "$outfolder/$file"
        avconv -y -i "$file" -acodec libvorbis -ab 96k -ss 0 -t $len "$outfolder/$out"

done

echo "---"
echo "JSON:"
echo "Use this in your {pick:'randomly'} or as single song for player.playMusic({...}) arguments."
echo "--- 8< ---"
echo "$json"|sed "s/\\\\n/\n/g"
echo "--- >8 ---"
echo ""
echo "HTML:"
echo "Use this in project homepages."
echo "--- 8< ---"
echo "$html"|sed "s/\\\\n/\n/g"
echo "--- >8 ---"
echo ""